/**********************************************************************
   PIC12F675
  MikroC Pro for Pic 6.0.0

************************************************************/


#define   Out_M   GPIO.F5   // 
#define   Out_T   GPIO.F2   // 

void Init_CPU( void );
unsigned char ReadADC( ADC );

unsigned char Up,  Up_on;
/**********************
     
************************/
unsigned char ReadADC( unsigned char ADC )
{
   unsigned int adc_old, adcsum = 0; //    
   unsigned char adctek,  i, del;
   ADCON0 = ( ( ADC << 2 ) | 0x01 ); //12F675,16F688

   for ( i = 0; i < 8; i++ )        //  8
   {
      ADIF_bit = 0;
      ADRESH = 0;
      del = 10;

      while ( del-- );

      GO_DONE_bit = 1;         //

      while ( !ADIF_bit );      

      adctek = ADRESH;

      if ( i == 0 )
      {
         adc_old = adctek;     //     
         adcsum = adc_old;
      }
      else
      {
         adc_old += adctek;    //     
         adc_old /= 2;         //   2
         adcsum += adc_old;    // 
      }
   }

   adctek = adcsum / 8;        //  c   8
   return adctek;              //   
}

/*======================
  .
======================*/
void Init_CPU( void )
{
   GPIO = 0;                   // GPIO
   INTCON = 0;
   OPTION_REG = 0b100001111;   //..,. WDT,.=128:
   TRISIO = 0b00011011;        //2,5 out
   WPU = 0;
   //   .
   ANSEL = 0b01011000;         //an3  , Fosc/16
   ADCON0 = 0;                 // ,  VDD
   CMCON = 0x07;               // .
}
/**************************************************************/
void main( void )
{
   Init_CPU();
   Out_T = 1;
   Delay_ms( 200 );            //
   Out_T = 0;
   Delay_ms( 2000 );           //  

   while ( 1 )
   {
      Out_T = 1;               // 
      Up = ReadADC( 3 );
      Up_on = ( Up + Up / 8 ); //  (1/16,1/8+1/16,1/4)

      while ( Up < Up_on )     //  
      {
         Up = ReadADC( 3 );
         continue;
      }

      Out_T = 0;
      Delay_ms( 10 );
      Out_M = 1;               //   
      Delay_ms( 1000 );
      Out_M = 0;
      Delay_ms( 2500 );        //  
   }
}